<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TIGL: /home/mohamed/code/tigl/src/standard/benchmark/tiglBenchmarkVertexPageR.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TIGL
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search", false, 'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Groups</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_512e97a87e29490d503e7e4403f25482.html">standard</a></li><li class="navelem"><a class="el" href="dir_c8a6b44b51a505c59ee83482c1b4fd3c.html">benchmark</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">tiglBenchmarkVertexPageR.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * tiglBenchmarkVertexPageR.hpp</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * Vertex Class definition of pageR algorithm</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> *  Created on: Apr 16, 2014</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *      Author: Mohamed Mansour</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> */</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;</div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#ifndef VERTEXPAGER_HPP_</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#define VERTEXPAGER_HPP_</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &quot;tiglContainersVertexBase.hpp&quot;</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment">/*algorithm data for PageR Vertex*/</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DataType, <span class="keyword">typename</span> IdType = <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span>&gt;</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="keyword">class </span>vertexPageR:</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;        <span class="keyword">public</span> <a class="code" href="classbi__vertex.html">bi_vertex</a>&lt;DataType, double, TIGLContainersEdgeBase&lt;IdType&gt;, IdType&gt;</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;{</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    <span class="keyword">typedef</span> <a class="code" href="classEdgeBase.html">TIGLContainersEdgeBase&lt;IdType&gt;</a> EdgeType;</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <span class="keyword">typedef</span> <a class="code" href="classbi__vertex.html">bi_vertex&lt;DataType, double, EdgeType, IdType&gt;</a> vertex_base;</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> vertex_base::IN_EDGE_ITERATOR IN_EDGE_ITERATOR;</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> vertex_base::OUT_EDGE_ITERATOR OUT_EDGE_ITERATOR;</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    vertexPageR(IdType key) : <a class="code" href="classbi__vertex.html">bi_vertex</a>&lt;DataType, double, <a class="code" href="classEdgeBase.html">TIGLContainersEdgeBase</a>&lt;IdType&gt;, IdType&gt;(key) {}</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    ~vertexPageR(){}</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    IdType numVertices;</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <span class="keywordtype">double</span> alpha;</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <span class="keywordtype">double</span> threshold ;</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <span class="keywordtype">void</span> init(IdType totalVertics, <span class="keywordtype">double</span> inAlpha = 0.85, <span class="keywordtype">double</span> inThreshold = 1e-6){</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;        <span class="comment">/*initializing the algData field and calling the base initialization function*/</span></div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;        numVertices = totalVertics;</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;        alpha = inAlpha;</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;        threshold = inThreshold ;</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;        this-&gt;<a class="code" href="classVertexBase.html#a1194c063341fb9886a4836d30baaec86">algData</a> = 1.0/numVertices;</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;        vertex_base::init();</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    }</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <span class="keywordtype">bool</span> compute(<span class="keywordtype">void</span> * pIn = 0, <span class="keywordtype">void</span> * pOut = 0) {</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;        <span class="keyword">typename</span> vector&lt;vertexPageR&gt;::iterator itStart = (*((vector&lt;vertexPageR&gt;*)pIn)).begin();</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;        <span class="keywordtype">double</span> newRank = 0;</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;        <span class="comment">/*combining the output*/</span></div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;        <span class="keywordflow">for</span>(IN_EDGE_ITERATOR it = this-&gt;getBeginInEdgeIterator();</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;                    it != this-&gt;getEndInEdgeIterator(); ++it)</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;        {</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;            <span class="keywordflow">if</span>(it-&gt;getNbr() == this-&gt;<a class="code" href="classVertexBase.html#a68eb54bdc5fc2b3af1396af8e78fda05">id</a>)</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;                <span class="keywordflow">continue</span>;<span class="comment">// ignoring self loops</span></div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;            <span class="keyword">typename</span> vector&lt;vertexPageR&gt;::iterator itSrc = itStart  + it-&gt;getNbr();</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;            newRank += itSrc-&gt;getAlgData()/itSrc-&gt;getNumOutEdges();<span class="comment">//it-&gt;getAlgData(); /*note that *it is itself an iterator */</span></div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        }</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;        newRank *= alpha;</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;        newRank += (1.0-alpha)/numVertices;</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;        <span class="keywordflow">if</span>(newRank - this-&gt;algData &gt; threshold ||  newRank - this-&gt;algData &lt; -threshold)</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;        {<span class="comment">/* now putting the newRank at the output edges if it is significantly different from the old value*/</span></div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;            this-&gt;<a class="code" href="classVertexBase.html#a1194c063341fb9886a4836d30baaec86">algData</a> = newRank;</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;<span class="comment">//          double updatedVal = newRank/this-&gt;getNumOutEdges();</span></div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;<span class="comment">//          for(OUT_EDGE_ITERATOR it = this-&gt;get_out_edge_iterator();</span></div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;<span class="comment">//                  it != this-&gt;get_end_out_edge_iterator(); ++it)</span></div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;<span class="comment">//          {</span></div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;<span class="comment">//              it-&gt;compute((void*) &amp;updatedVal);</span></div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;<span class="comment">//          }</span></div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;            <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;        }</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;        <span class="keywordflow">else</span></div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;            <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    }</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;};</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* VERTEXPAGER_HPP_ */</span><span class="preprocessor"></span></div>
<div class="ttc" id="classVertexBase_html_a68eb54bdc5fc2b3af1396af8e78fda05"><div class="ttname"><a href="classVertexBase.html#a68eb54bdc5fc2b3af1396af8e78fda05">TIGLContainersVertexBase::id</a></div><div class="ttdeci">IdType id</div><div class="ttdoc">unique vertex ID </div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:72</div></div>
<div class="ttc" id="classbi__vertex_html"><div class="ttname"><a href="classbi__vertex.html">bi_vertex</a></div><div class="ttdoc">A vertex class with both input and output edges lists it inherits all the properties of regular verte...</div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:230</div></div>
<div class="ttc" id="classEdgeBase_html"><div class="ttname"><a href="classEdgeBase.html">TIGLContainersEdgeBase</a></div><div class="ttdoc">core edge class </div><div class="ttdef"><b>Definition:</b> tiglContainersEdgeBase.hpp:30</div></div>
<div class="ttc" id="classVertexBase_html_a1194c063341fb9886a4836d30baaec86"><div class="ttname"><a href="classVertexBase.html#a1194c063341fb9886a4836d30baaec86">TIGLContainersVertexBase&lt; DataType, double, TIGLContainersEdgeBase&lt; IdType &gt;, IdType &gt;::algData</a></div><div class="ttdeci">double algData</div><div class="ttdoc">Algorithm-specific data. </div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:78</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Mon Oct 20 2014 16:19:13 for TIGL by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
